/// <reference types="node" />
import type { ComponentInstance, RouteData } from '../../@types/astro';
import type { LogOptions } from '../logger/core';
import type http from 'http';
import { createContainer, type CreateContainerParams } from '../dev/index.js';
import { App } from './index.js';
import { RenderContext, Environment } from '../render';
export declare const logging: LogOptions;
export type DevAppParams = Partial<CreateContainerParams> & {
    root: URL;
};
export declare class DevApp extends App {
    #private;
    container: Awaited<ReturnType<typeof createContainer>> | null;
    constructor(params: DevAppParams);
    get loaded(): boolean;
    url(pathname: string): string | undefined;
    load(): Promise<this>;
    close(): Promise<void>;
    fileChanged(path: string): void;
    handle(req: http.IncomingMessage, res: http.ServerResponse): void;
    render(request: Request, route?: RouteData | undefined): Promise<Response>;
    renderPage: (mod: ComponentInstance, ctx: RenderContext, env: Environment) => Promise<Response>;
}
